﻿
var chartControl;
$(function () {
    var data = [];
    var dataArray = [];

    for (var i = 0; i < data.length; i++) {
        dataArray.push([data[i].X, data[i].DriverStatus]);
    }

    chartControl = new Highcharts.Chart({
        chart: {
            renderTo: 'container',
            plotBackgroundColor: null,
            plotBorderWidth: null,
            plotShadow: false,
            backgroundColor: 'transparent'
        },
        credits: {
            enabled: false
        },
        title: {
            text: ''
        },
        tooltip: {
            formatter: function () {
                var yName = '';
                switch (this.y) {
                    case 1:
                        yName = 'On Duty';
                        break;
                    case 2:
                        yName = 'Driving';
                        break;
                    case 3:
                        yName = 'Sleeper';
                        break;
                    case 4:
                        yName = 'Off Duty';
                        break;
                }

                var timeSeconds = Highcharts.numberFormat(this.x, 1) * 60;
                var timeMin = (timeSeconds - timeSeconds % 60) / 60;
                var timeSec = timeSeconds % 60;
                return '<b>' + yName + '</b><br/>' +
                    'Time: ' + timeMin + ':' + timeSec;
            }
        },
        labels:
        {
            enabled: false
        },
        legend: {
            enabled: false
        },
        yAxis: {
            tickInterval: 1,
            labels: {
                enabled: false,
                formatter: function () {
                    switch (this.value) {
                        case 1:
                            return 'On Duty';
                        case 2:
                            return 'Driving';
                        case 3:
                            return 'Sleeper';
                        case 4:
                            return 'Off Duty';
                        default:
                            return '';
                    }
                }
            },
            gridLineColor: 'transparent',
            startOnTick: false,
            endOnTick: false,
            max: 4.3,
            min: 0.7,
            title: {
                text: null
            },
            allowDecimals: false
        },
        xAxis: {
            labels: {
                enabled: true
            },
            allowDecimals: false,
            tickInterval: 1,
            minorTickInterval: 0.25,
            gridLineColor: 'transparent',
            minorGridLineColor: 'transparent',
            gridLineWidth: 1,
            minorGridLineWidth: 1,
            minRange: 24,
            min: 0
        },
        series: [{
            marker: {
                enabled: false
            },
            type: 'line',
            lineWidth: 5,
            data: dataArray,
            step: true
        }]
    });



});

function ReloadGraph(data) {
    var newData = [];
    for (var i = 0; i < data.length; i++) {
        newData.push([data[i].X,data[i].DriverStatus]);
    }
    if (chartControl != undefined) {
        chartControl.series[0].setData(newData, true, false, false);
    }
}

function UpdateLastPoint(data) {
    if (chartControl != undefined) {
        var chartData = chartControl.series[0].data;

        if (chartData.length != 0)
            chartData[chartData.length - 1].update([data.X, data.DriverStatus]);
    }
}
